]> git.ipfire.org Git - people/mfischer/ipfire-2.x.git/blob - make.sh
libsolv: Removal from IPFire
[people/mfischer/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ###############################################################################
3 # #
4 # IPFire.org - A linux based firewall #
5 # Copyright (C) 2007-2022 IPFire Team <info@ipfire.org> #
6 # #
7 # This program is free software: you can redistribute it and/or modify #
8 # it under the terms of the GNU General Public License as published by #
9 # the Free Software Foundation, either version 3 of the License, or #
10 # (at your option) any later version. #
11 # #
12 # This program is distributed in the hope that it will be useful, #
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
15 # GNU General Public License for more details. #
16 # #
17 # You should have received a copy of the GNU General Public License #
18 # along with this program. If not, see <http://www.gnu.org/licenses/>. #
19 # #
20 ###############################################################################
21
22 NAME="IPFire" # Software name
23 SNAME="ipfire" # Short name
24 # If you update the version don't forget to update backupiso and add it to core update
25 VERSION="2.27" # Version number
26 CORE="167" # Core Level (Filename)
27 SLOGAN="www.ipfire.org" # Software slogan
28 CONFIG_ROOT=/var/ipfire # Configuration rootdir
29 MAX_RETRIES=1 # prefetch/check loop
30 BUILD_IMAGES=1 # Flash and Xen Downloader
31 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
32
33 # Information from Git
34 GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
35 GIT_TAG="$(git tag | tail -1)" # Git Tag
36 GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
37
38 TOOLCHAINVER=20220203
39
40 # use multicore and max compression
41 ZSTD_OPT="-T0 --ultra -22"
42
43 ###############################################################################
44 #
45 # Beautifying variables & presentation & input output interface
46 #
47 ###############################################################################
48
49 # Remember if the shell is interactive or not
50 if [ -t 0 ] && [ -t 1 ]; then
51 INTERACTIVE=true
52 else
53 INTERACTIVE=false
54 fi
55
56 # Sets or adjusts pretty formatting variables
57 resize_terminal() {
58 ## Screen Dimentions
59 # Find current screen size
60 COLUMNS=$(tput cols)
61
62 # When using remote connections, such as a serial port, stty size returns 0
63 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
64 COLUMNS=80
65 fi
66
67 # Measurements for positioning result messages
68 OPTIONS_WIDTH=20
69 TIME_WIDTH=12
70 STATUS_WIDTH=8
71 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
72 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
73
74 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
75 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
76 }
77
78 # Initially setup terminal
79 resize_terminal
80
81 # Call resize_terminal when terminal is being resized
82 trap "resize_terminal" WINCH
83
84 # Define color for messages
85 BOLD="\\033[1;39m"
86 DONE="\\033[1;32m"
87 SKIP="\\033[1;34m"
88 WARN="\\033[1;35m"
89 FAIL="\\033[1;31m"
90 NORMAL="\\033[0;39m"
91
92 # New architecture variables
93 HOST_ARCH="$(uname -m)"
94
95 PWD=$(pwd)
96 BASENAME=$(basename $0)
97
98 # Debian specific settings
99 if [ ! -e /etc/debian_version ]; then
100 FULLPATH=`which $0`
101 else
102 if [ -x /usr/bin/realpath ]; then
103 FULLPATH=`/usr/bin/realpath $0`
104 else
105 echo "ERROR: Need to do apt-get install realpath"
106 exit 1
107 fi
108 fi
109
110 # This is the directory where make.sh is in
111 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
112
113 LOGFILE=$BASEDIR/log/_build.preparation.log
114 export LOGFILE
115 DIR_CHK=$BASEDIR/cache/check
116 mkdir $BASEDIR/log/ 2>/dev/null
117
118 system_processors() {
119 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
120 }
121
122 system_memory() {
123 local key val unit
124
125 while read -r key val unit; do
126 case "${key}" in
127 MemTotal:*)
128 # Convert to MB
129 echo "$(( ${val} / 1024 ))"
130 break
131 ;;
132 esac
133 done < /proc/meminfo
134 }
135
136 configure_build() {
137 local build_arch="${1}"
138
139 if [ "${build_arch}" = "default" ]; then
140 build_arch="$(configure_build_guess)"
141 fi
142
143 case "${build_arch}" in
144 x86_64)
145 BUILDTARGET="${build_arch}-pc-linux-gnu"
146 CROSSTARGET="${build_arch}-cross-linux-gnu"
147 BUILD_PLATFORM="x86"
148 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
149 ;;
150
151 aarch64)
152 BUILDTARGET="${build_arch}-pc-linux-gnu"
153 CROSSTARGET="${build_arch}-cross-linux-gnu"
154 BUILD_PLATFORM="arm"
155 CFLAGS_ARCH="-fstack-clash-protection"
156 ;;
157
158 armv7hl)
159 BUILDTARGET="${build_arch}-pc-linux-gnueabi"
160 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
161 BUILD_PLATFORM="arm"
162 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
163 ;;
164
165 armv6l)
166 BUILDTARGET="${build_arch}-pc-linux-gnueabi"
167 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
168 BUILD_PLATFORM="arm"
169 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
170 ;;
171
172 riscv64)
173 BUILDTARGET="${build_arch}-pc-linux-gnu"
174 CROSSTARGET="${build_arch}-cross-linux-gnu"
175 BUILD_PLATFORM="riscv"
176 CFLAGS_ARCH="-fstack-clash-protection"
177 ;;
178
179 *)
180 exiterror "Cannot build for architure ${build_arch}"
181 ;;
182 esac
183
184 # Check if the QEMU helper is available if needed.
185 if qemu_is_required "${build_arch}"; then
186 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
187
188 if [ -n "${qemu_build_helper}" ]; then
189 QEMU_TARGET_HELPER="${qemu_build_helper}"
190 else
191 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
192 fi
193 fi
194
195 BUILD_ARCH="${build_arch}"
196 TOOLS_DIR="/tools_${BUILD_ARCH}"
197
198 # Enables hardening
199 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
200
201 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
202 CXXFLAGS="${CFLAGS}"
203
204 RUSTFLAGS="-Copt-level=3 -Clink-arg=-Wl,-z,relro,-z,now -Ccodegen-units=1 --cap-lints=warn ${RUSTFLAGS_ARCH}"
205
206 # Determine parallelism
207 # We assume that each process consumes about
208 # 128MB of memory. Therefore we find out how
209 # many processes fit into memory.
210 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
211 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
220 # Use this as default PARALLELISM
221 DEFAULT_PARALLELISM="${parallelism}"
222
223 # Limit lauched ninja build jobs to computed parallel value.
224 NINJAJOBS="${parallelism}"
225
226 # Compression parameters
227 # We use mode 8 for reasonable memory usage when decompressing
228 # but with overall good compression
229 XZ_OPT="-8"
230
231 # We try to use as many cores as possible
232 XZ_OPT="${XZ_OPT} -T0"
233
234 # We need to limit memory because XZ uses too much when running
235 # in parallel and it isn't very smart in limiting itself.
236 # We allow XZ to use up to 70% of all system memory.
237 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
238
239 # XZ memory cannot be larger than 2GB on 32 bit systems
240 case "${build_arch}" in
241 armv*)
242 if [ ${xz_memory} -gt 2048 ]; then
243 xz_memory=2048
244 fi
245 ;;
246 esac
247
248 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
249 }
250
251 configure_build_guess() {
252 case "${HOST_ARCH}" in
253 x86_64)
254 echo "x86_64"
255 ;;
256
257 aarch64)
258 echo "aarch64"
259 ;;
260
261 armv7*|armv6*)
262 echo "armv6l"
263 ;;
264
265 riscv64)
266 echo "riscv64"
267 ;;
268
269 *)
270 exiterror "Cannot guess build architecture"
271 ;;
272 esac
273 }
274
275 stdumount() {
276 umount $BASEDIR/build/sys 2>/dev/null;
277 umount $BASEDIR/build/dev/shm 2>/dev/null;
278 umount $BASEDIR/build/dev/pts 2>/dev/null;
279 umount $BASEDIR/build/dev 2>/dev/null;
280 umount $BASEDIR/build/proc 2>/dev/null;
281 umount $BASEDIR/build/install/mnt 2>/dev/null;
282 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
283 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
284 umount $BASEDIR/build/usr/src/config 2>/dev/null;
285 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
286 umount $BASEDIR/build/usr/src/html 2>/dev/null;
287 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
288 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
289 umount $BASEDIR/build/usr/src/log 2>/dev/null;
290 umount $BASEDIR/build/usr/src/src 2>/dev/null;
291 umount $BASEDIR/build/usr/src 2>/dev/null;
292 umount $BASEDIR/build/tmp 2>/dev/null;
293 }
294
295 format_runtime() {
296 local seconds=${1}
297
298 if [ ${seconds} -ge 3600 ]; then
299 printf "%d:%02d:%02d\n" \
300 "$(( seconds / 3600 ))" \
301 "$(( seconds % 3600 / 60 ))" \
302 "$(( seconds % 3600 % 60 ))"
303 elif [ ${seconds} -ge 60 ]; then
304 printf "%d:%02d\n" \
305 "$(( seconds / 60 ))" \
306 "$(( seconds % 60 ))"
307 else
308 printf "%d\n" "${seconds}"
309 fi
310 }
311
312 print_line() {
313 local line="$@"
314
315 printf "%-${LINE_WIDTH}s" "${line}"
316 }
317
318 _print_line() {
319 local status="${1}"
320 shift
321
322 if ${INTERACTIVE}; then
323 printf "${!status}"
324 fi
325
326 print_line "$@"
327
328 if ${INTERACTIVE}; then
329 printf "${NORMAL}"
330 fi
331 }
332
333 print_headline() {
334 _print_line BOLD "$@"
335 }
336
337 print_error() {
338 _print_line FAIL "$@"
339 }
340
341 print_package() {
342 local name="${1}"
343 shift
344
345 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
346 local options="$@"
347
348 local string="${name}"
349 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
350 string="${string} (${version})"
351 fi
352
353 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
354 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
355 }
356
357 print_runtime() {
358 local runtime=$(format_runtime $@)
359
360 if ${INTERACTIVE}; then
361 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
362 else
363 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
364 fi
365 }
366
367 print_status() {
368 local status="${1}"
369
370 local color="${!status}"
371
372 if ${INTERACTIVE}; then
373 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
374 else
375 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
376 fi
377 }
378
379 print_build_stage() {
380 print_headline "$@"
381
382 # end line
383 printf "\n"
384 }
385
386 print_build_summary() {
387 local runtime=$(format_runtime $@)
388
389 print_line "*** Build finished in ${runtime}"
390 print_status DONE
391 }
392
393 exiterror() {
394 stdumount
395 for i in `seq 0 7`; do
396 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
397 losetup -d /dev/loop${i} 2>/dev/null
398 fi;
399 done
400
401 # Dump logfile
402 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
403 echo # empty line
404
405 local line
406 while read -r line; do
407 echo " ${line}"
408 done <<< "$(tail -n30 ${LOGFILE})"
409 fi
410
411 echo # empty line
412
413 local line
414 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
415 print_error "${line}"
416 print_status FAIL
417 done
418
419 exit 1
420 }
421
422 prepareenv() {
423 # Are we running the right shell?
424 if [ -z "${BASH}" ]; then
425 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
426 fi
427
428 if [ -z "${BASH_VERSION}" ]; then
429 exiterror "Not running BASH shell."
430 fi
431
432 # Trap on emergency exit
433 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGQUIT
434
435 # Checking if running as root user
436 if [ $(id -u) -ne 0 ]; then
437 exiterror "root privileges required for building"
438 fi
439
440 # Checking for necessary temporary space
441 print_line "Checking for necessary space on disk $BASE_DEV"
442 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
443 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
444 if (( 2048000 > $BASE_ASPACE )); then
445 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
446 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
447 print_status FAIL
448 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
449 fi
450 else
451 print_status DONE
452 fi
453
454 # Set umask
455 umask 022
456
457 # Set LFS Directory
458 LFS=$BASEDIR/build
459
460 # Setup environment
461 set +h
462 LC_ALL=POSIX
463 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
464 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
465
466 # Make some extra directories
467 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
468 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
469 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
470 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
471
472 if [ "${ENABLE_RAMDISK}" = "on" ]; then
473 mkdir -p $BASEDIR/build/usr/src
474 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
475
476 mkdir -p ${BASEDIR}/build/tmp
477 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
478 fi
479
480 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
481
482 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
483 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
484
485 # Make all sources and proc available under lfs build
486 mount --bind /dev $BASEDIR/build/dev
487 mount --bind /dev/pts $BASEDIR/build/dev/pts
488 mount --bind /dev/shm $BASEDIR/build/dev/shm
489 mount --bind /proc $BASEDIR/build/proc
490 mount --bind /sys $BASEDIR/build/sys
491 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
492 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
493 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
494 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
495 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
496 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
497 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
498 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
499 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
500
501 # Run LFS static binary creation scripts one by one
502 export CCACHE_DIR=$BASEDIR/ccache
503 export CCACHE_TEMPDIR="/tmp"
504 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
505
506 # Remove pre-install list of installed files in case user erase some files before rebuild
507 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
508
509 # Prepare string for /etc/system-release.
510 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
511
512 case "${GIT_BRANCH}" in
513 core*|beta?|rc?)
514 system_release="${system_release} - ${GIT_BRANCH}"
515 ;;
516 *)
517 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
518 ;;
519 esac
520
521 # Append -dirty tag for local changes
522 if [ "$(git status -s | wc -l)" != "0" ]; then
523 system_release="${system_release}-dirty"
524 fi
525
526 # Export variable
527 SYSTEM_RELEASE="${system_release}"
528
529 # Decide on PAKFIRE_TREE
530 case "${GIT_BRANCH}" in
531 core*)
532 PAKFIRE_TREE="stable"
533 ;;
534 master)
535 PAKFIRE_TREE="testing"
536 ;;
537 *)
538 PAKFIRE_TREE="unstable"
539 ;;
540 esac
541
542 # Setup ccache cache size
543 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}"
544 }
545
546 enterchroot() {
547 # Install QEMU helper, if needed
548 qemu_install_helper
549
550 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin"
551
552 # Prepend any custom changes to PATH
553 if [ -n "${CUSTOM_PATH}" ]; then
554 PATH="${CUSTOM_PATH}:${PATH}"
555 fi
556
557 PATH="${PATH}" chroot ${LFS} env -i \
558 HOME="/root" \
559 TERM="${TERM}" \
560 PS1="${PS1}" \
561 PATH="${PATH}" \
562 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
563 PAKFIRE_TREE="${PAKFIRE_TREE}" \
564 NAME="${NAME}" \
565 SNAME="${SNAME}" \
566 VERSION="${VERSION}" \
567 CORE="${CORE}" \
568 SLOGAN="${SLOGAN}" \
569 TOOLS_DIR="${TOOLS_DIR}" \
570 CONFIG_ROOT="${CONFIG_ROOT}" \
571 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
572 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
573 RUSTFLAGS="${RUSTFLAGS}" \
574 BUILDTARGET="${BUILDTARGET}" \
575 CROSSTARGET="${CROSSTARGET}" \
576 BUILD_ARCH="${BUILD_ARCH}" \
577 BUILD_PLATFORM="${BUILD_PLATFORM}" \
578 CCACHE_DIR=/usr/src/ccache \
579 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
580 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
581 GOCACHE="/usr/src/ccache/go" \
582 KVER="${KVER}" \
583 XZ_OPT="${XZ_OPT}" \
584 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
585 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
586 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
587 $(fake_environ) \
588 $(qemu_environ) \
589 "$@"
590 }
591
592 entershell() {
593 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
594 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
595 fi
596
597 echo "Entering to a shell inside LFS chroot, go out with exit"
598 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
599
600 if enterchroot bash -i; then
601 stdumount
602 else
603 print_status FAIL
604 exiterror "chroot error"
605 fi
606 }
607
608 lfsmakecommoncheck() {
609 # Script present?
610 if [ ! -f $BASEDIR/lfs/$1 ]; then
611 exiterror "No such file or directory: $BASEDIR/$1"
612 fi
613
614 # Print package name and version
615 print_package $@
616
617 # Check if this package is supported by our architecture.
618 # If no SUP_ARCH is found, we assume the package can be built for all.
619 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
620 # Check if package supports ${BUILD_ARCH} or all architectures.
621 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
622 print_runtime 0
623 print_status SKIP
624 return 1
625 fi
626 fi
627
628 # Script slipped?
629 local i
630 for i in $SKIP_PACKAGE_LIST
631 do
632 if [ "$i" == "$1" ]; then
633 print_status SKIP
634 return 1;
635 fi
636 done
637
638 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
639
640 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
641 MESSAGE="$1\t " download >> $LOGFILE 2>&1
642 if [ $? -ne 0 ]; then
643 exiterror "Download error in $1"
644 fi
645
646 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
647 MESSAGE="$1\t b2sum" b2 >> $LOGFILE 2>&1
648 if [ $? -ne 0 ]; then
649 exiterror "BLAKE2 checksum error in $1, check file in cache or signature"
650 fi
651
652 return 0 # pass all!
653 }
654
655 lfsmake1() {
656 lfsmakecommoncheck $*
657 [ $? == 1 ] && return 0
658
659 # Set PATH to use the toolchain tools first and then whatever the host has set
660 local PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/sbin:${TOOLS_DIR}/bin:${PATH}"
661
662 if [ -n "${CUSTOM_PATH}" ]; then
663 PATH="${CUSTOM_PATH}:${PATH}"
664 fi
665
666 cd $BASEDIR/lfs && env -i \
667 PATH="${PATH}" \
668 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
669 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
670 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
671 CFLAGS="${CFLAGS}" \
672 CXXFLAGS="${CXXFLAGS}" \
673 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
674 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
675 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
676 make -f $* \
677 TOOLCHAIN=1 \
678 TOOLS_DIR="${TOOLS_DIR}" \
679 CROSSTARGET="${CROSSTARGET}" \
680 BUILDTARGET="${BUILDTARGET}" \
681 BUILD_ARCH="${BUILD_ARCH}" \
682 BUILD_PLATFORM="${BUILD_PLATFORM}" \
683 LFS_BASEDIR="${BASEDIR}" \
684 ROOT="${LFS}" \
685 KVER="${KVER}" \
686 install >> $LOGFILE 2>&1 &
687
688 if ! wait_until_finished $!; then
689 print_status FAIL
690 exiterror "Building $*"
691 fi
692
693 print_status DONE
694 }
695
696 lfsmake2() {
697 lfsmakecommoncheck $*
698 [ $? == 1 ] && return 0
699
700 local PS1='\u:\w$ '
701
702 enterchroot \
703 bash -x -c "cd /usr/src/lfs && \
704 make -f $* \
705 LFS_BASEDIR=/usr/src install" \
706 >> ${LOGFILE} 2>&1 &
707
708 if ! wait_until_finished $!; then
709 print_status FAIL
710 exiterror "Building $*"
711 fi
712
713 print_status DONE
714 }
715
716 ipfiredist() {
717 lfsmakecommoncheck $*
718 [ $? == 1 ] && return 0
719
720 local PS1='\u:\w$ '
721
722 enterchroot \
723 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
724 >> ${LOGFILE} 2>&1 &
725
726 if ! wait_until_finished $!; then
727 print_status FAIL
728 exiterror "Packaging $*"
729 fi
730
731 print_status DONE
732 }
733
734 wait_until_finished() {
735 local pid=${1}
736
737 local start_time="${SECONDS}"
738
739 # Show progress
740 if ${INTERACTIVE}; then
741 # Wait a little just in case the process
742 # has finished very quickly.
743 sleep 0.1
744
745 local runtime
746 while kill -0 ${pid} 2>/dev/null; do
747 print_runtime $(( SECONDS - start_time ))
748
749 # Wait a little
750 sleep 1
751 done
752 fi
753
754 # Returns the exit code of the child process
755 wait ${pid}
756 local ret=$?
757
758 if ! ${INTERACTIVE}; then
759 print_runtime $(( SECONDS - start_time ))
760 fi
761
762 return ${ret}
763 }
764
765 fake_environ() {
766 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
767
768 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
769
770 # Fake kernel version, because some of the packages do not compile
771 # with kernel 3.0 and later.
772 env="${env} UTS_RELEASE=${KVER}-ipfire"
773
774 # Fake machine version.
775 env="${env} UTS_MACHINE=${BUILD_ARCH}"
776
777 echo "${env}"
778 }
779
780 qemu_environ() {
781 local env="QEMU_TARGET_HELPER=${QEMU_TARGET_HELPER}"
782
783 # Don't add anything if qemu is not used.
784 if ! qemu_is_required; then
785 return
786 fi
787
788 # Set default qemu options
789 case "${BUILD_ARCH}" in
790 arm*)
791 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
792
793 env="${env} QEMU_CPU=${QEMU_CPU}"
794 ;;
795 riscv64)
796 QEMU_CPU="${QEMU_CPU:-sifive-u54}"
797
798 env="${env} QEMU_CPU=${QEMU_CPU}"
799 ;;
800 esac
801
802 # Enable QEMU strace
803 #env="${env} QEMU_STRACE=1"
804
805 echo "${env}"
806 }
807
808 qemu_is_required() {
809 local build_arch="${1}"
810
811 if [ -z "${build_arch}" ]; then
812 build_arch="${BUILD_ARCH}"
813 fi
814
815 case "${HOST_ARCH},${build_arch}" in
816 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
817 return 0
818 ;;
819 *)
820 return 1
821 ;;
822 esac
823 }
824
825 qemu_install_helper() {
826 # Do nothing, if qemu is not required
827 if ! qemu_is_required; then
828 return 0
829 fi
830
831 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
832 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
833 fi
834
835 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
836 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
837 fi
838
839
840 if [ -z "${QEMU_TARGET_HELPER}" ]; then
841 exiterror "QEMU_TARGET_HELPER not set"
842 fi
843
844 # Check if the helper is already installed.
845 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
846 return 0
847 fi
848
849 # Try to find a suitable binary that we can install
850 # to the build environment.
851 local file
852 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
853 # file must exist and be executable.
854 [ -x "${file}" ] || continue
855
856 # Must be static.
857 file_is_static "${file}" || continue
858
859 local dirname="${LFS}$(dirname "${file}")"
860 mkdir -p "${dirname}"
861
862 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
863 return 0
864 done
865
866 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
867 }
868
869 qemu_find_build_helper_name() {
870 local build_arch="${1}"
871
872 local magic
873 case "${build_arch}" in
874 aarch64)
875 magic="7f454c460201010000000000000000000200b700"
876 ;;
877 arm*)
878 magic="7f454c4601010100000000000000000002002800"
879 ;;
880 riscv64)
881 magic="7f454c460201010000000000000000000200f300"
882 ;;
883 x86_64)
884 magic="7f454c4602010100000000000000000002003e00"
885 ;;
886 esac
887
888 [ -z "${magic}" ] && return 1
889
890 local file
891 for file in /proc/sys/fs/binfmt_misc/*; do
892 # skip write only register entry
893 [ $(basename "${file}") = "register" ] && continue
894 # Search for the file with the correct magic value.
895 grep -qE "^magic ${magic}$" "${file}" || continue
896
897 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
898
899 [ -n "${interpreter}" ] || continue
900 [ "${interpreter:0:1}" = "/" ] || continue
901 [ -x "${interpreter}" ] || continue
902
903 echo "${interpreter}"
904 return 0
905 done
906
907 return 1
908 }
909
910 file_is_static() {
911 local file="${1}"
912
913 file -L "${file}" 2>/dev/null | grep -q "statically linked"
914 }
915
916 update_language_list() {
917 local path="${1}"
918
919 local lang
920 for lang in ${path}/*.po; do
921 lang="$(basename "${lang}")"
922 echo "${lang%*.po}"
923 done | sort -u > "${path}/LINGUAS"
924 }
925
926 contributors() {
927 local commits name
928
929 git shortlog --summary --numbered | while read -r commits name; do
930 echo "${name}"
931 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
932 }
933
934 update_contributors() {
935 echo -n "Updating list of contributors"
936
937 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
938
939 # Edit contributors into credits.cgi
940 local tmp="$(mktemp)"
941
942 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
943 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
944
945 # Copy back modified content
946 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
947 unlink "${tmp}"
948
949 print_status DONE
950 return 0
951 }
952
953 # Default settings
954 CCACHE_CACHE_SIZE="4G"
955 ENABLE_RAMDISK="auto"
956
957 # Load configuration file
958 if [ -f .config ]; then
959 . .config
960 fi
961
962 # TARGET_ARCH is BUILD_ARCH now
963 if [ -n "${TARGET_ARCH}" ]; then
964 BUILD_ARCH="${TARGET_ARCH}"
965 unset TARGET_ARCH
966 fi
967
968 # Get some information about the host system
969 SYSTEM_PROCESSORS="$(system_processors)"
970 SYSTEM_MEMORY="$(system_memory)"
971
972 if [ -n "${BUILD_ARCH}" ]; then
973 configure_build "${BUILD_ARCH}"
974 else
975 configure_build "default"
976 fi
977
978 # Automatically enable/disable ramdisk usage
979 if [ "${ENABLE_RAMDISK}" = "auto" ]; then
980 # Enable only when the host system has 4GB of RAM or more
981 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
982 ENABLE_RAMDISK="on"
983 fi
984 fi
985
986 buildtoolchain() {
987 local error=false
988 case "${BUILD_ARCH}:${HOST_ARCH}" in
989 # x86_64
990 x86_64:x86_64)
991 # This is working.
992 ;;
993
994 # ARM
995 arvm7hl:armv7hl|armv7hl:armv7l)
996 # These are working.
997 ;;
998
999 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
1000 # These are working.
1001 ;;
1002 armv6l:*)
1003 error=true
1004 ;;
1005 esac
1006
1007 ${error} && \
1008 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
1009
1010 local gcc=$(type -p gcc)
1011 if [ -z "${gcc}" ]; then
1012 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1013 fi
1014
1015 # Check ${TOOLS_DIR} symlink
1016 if [ -h "${TOOLS_DIR}" ]; then
1017 rm -f "${TOOLS_DIR}"
1018 fi
1019
1020 if [ ! -e "${TOOLS_DIR}" ]; then
1021 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1022 fi
1023
1024 if [ ! -h "${TOOLS_DIR}" ]; then
1025 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1026 fi
1027
1028 LOGFILE="$BASEDIR/log/_build.toolchain.log"
1029 export LOGFILE
1030
1031 lfsmake1 stage1
1032 lfsmake1 binutils PASS=1
1033 lfsmake1 gcc PASS=1
1034 lfsmake1 linux KCFG="-headers"
1035 lfsmake1 glibc
1036 lfsmake1 libxcrypt
1037 lfsmake1 gcc PASS=L
1038 lfsmake1 zlib
1039 lfsmake1 binutils PASS=2
1040 lfsmake1 gcc PASS=2
1041 lfsmake1 zstd
1042 lfsmake1 ccache
1043 lfsmake1 tcl
1044 lfsmake1 expect
1045 lfsmake1 dejagnu
1046 lfsmake1 pkg-config
1047 lfsmake1 ncurses
1048 lfsmake1 bash
1049 lfsmake1 bzip2
1050 lfsmake1 automake
1051 lfsmake1 coreutils
1052 lfsmake1 diffutils
1053 lfsmake1 findutils
1054 lfsmake1 gawk
1055 lfsmake1 gettext
1056 lfsmake1 grep
1057 lfsmake1 gzip
1058 lfsmake1 m4
1059 lfsmake1 make
1060 lfsmake1 patch
1061 lfsmake1 perl
1062 lfsmake1 python3
1063 lfsmake1 sed
1064 lfsmake1 tar
1065 lfsmake1 texinfo
1066 lfsmake1 xz
1067 lfsmake1 bison
1068 lfsmake1 flex
1069 lfsmake1 fake-environ
1070 CUSTOM_PATH="${PATH}" lfsmake1 strip
1071 lfsmake1 cleanup-toolchain
1072 }
1073
1074 buildbase() {
1075 LOGFILE="$BASEDIR/log/_build.base.log"
1076 export LOGFILE
1077 lfsmake2 stage2
1078 lfsmake2 linux KCFG="-headers"
1079 lfsmake2 man-pages
1080 lfsmake2 glibc
1081 lfsmake2 tzdata
1082 lfsmake2 cleanup-toolchain
1083 lfsmake2 zlib
1084 lfsmake2 zstd
1085 lfsmake2 autoconf
1086 lfsmake2 automake
1087 lfsmake2 libtool
1088 lfsmake2 binutils
1089 lfsmake2 gmp
1090 lfsmake2 mpfr
1091 lfsmake2 libmpc
1092 lfsmake2 libxcrypt
1093 lfsmake2 file
1094 lfsmake2 gcc
1095 lfsmake2 attr
1096 lfsmake2 acl
1097 lfsmake2 sed
1098 lfsmake2 berkeley
1099 lfsmake2 coreutils
1100 lfsmake2 iana-etc
1101 lfsmake2 m4
1102 lfsmake2 bison
1103 lfsmake2 ncurses
1104 lfsmake2 perl
1105 lfsmake2 readline
1106 lfsmake2 bzip2
1107 lfsmake2 xz
1108 lfsmake2 lzip
1109 lfsmake2 pcre
1110 lfsmake2 pcre2
1111 lfsmake2 gettext
1112 lfsmake2 bash
1113 lfsmake2 diffutils
1114 lfsmake2 ed
1115 lfsmake2 findutils
1116 lfsmake2 flex
1117 lfsmake2 gawk
1118 lfsmake2 go
1119 lfsmake2 grep
1120 lfsmake2 groff
1121 lfsmake2 gperf
1122 lfsmake2 gzip
1123 lfsmake2 hostname
1124 lfsmake2 whois
1125 lfsmake2 kbd
1126 lfsmake2 less
1127 lfsmake2 pkg-config
1128 lfsmake2 procps
1129 lfsmake2 make
1130 lfsmake2 man
1131 lfsmake2 net-tools
1132 lfsmake2 patch
1133 lfsmake2 psmisc
1134 lfsmake2 shadow
1135 lfsmake2 sysklogd
1136 lfsmake2 sysvinit
1137 lfsmake2 tar
1138 lfsmake2 texinfo
1139 lfsmake2 util-linux
1140 lfsmake2 vim
1141 lfsmake2 e2fsprogs
1142 lfsmake2 jq
1143 }
1144
1145 buildipfire() {
1146 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1147 export LOGFILE
1148 lfsmake2 configroot
1149 lfsmake2 initscripts
1150 lfsmake2 backup
1151 lfsmake2 rust
1152 lfsmake2 openssl
1153 lfsmake2 kmod
1154 lfsmake2 udev
1155 lfsmake2 popt
1156 lfsmake2 libedit
1157 lfsmake2 libusb
1158 lfsmake2 libusb-compat
1159 lfsmake2 libpcap
1160 lfsmake2 ppp
1161 lfsmake2 pptp
1162 lfsmake2 unzip
1163 lfsmake2 which
1164 lfsmake2 linux-firmware
1165 lfsmake2 dvb-firmwares
1166 lfsmake2 xr819-firmware
1167 lfsmake2 zd1211-firmware
1168 lfsmake2 rpi-firmware
1169 lfsmake2 intel-microcode
1170 lfsmake2 pcengines-apu-firmware
1171 lfsmake2 bc
1172 lfsmake2 u-boot MKIMAGE=1
1173 lfsmake2 cpio
1174 lfsmake2 mdadm
1175 lfsmake2 dracut
1176 lfsmake2 libaio
1177 lfsmake2 lvm2
1178 lfsmake2 multipath-tools
1179 lfsmake2 freetype
1180 lfsmake2 libmnl
1181 lfsmake2 libnfnetlink
1182 lfsmake2 libnetfilter_queue
1183 lfsmake2 libnetfilter_conntrack
1184 lfsmake2 libnetfilter_cthelper
1185 lfsmake2 libnetfilter_cttimeout
1186 lfsmake2 iptables
1187 lfsmake2 iproute2
1188 lfsmake2 screen
1189 lfsmake2 elfutils
1190
1191 # Kernelbuild ... current we have no platform that need
1192 # multi kernel builds so KCFG is empty
1193 lfsmake2 linux KCFG=""
1194 lfsmake2 rtl8189es KCFG=""
1195 lfsmake2 rtl8189fs KCFG=""
1196 lfsmake2 rtl8812au KCFG=""
1197 lfsmake2 rtl8822bu KCFG=""
1198 lfsmake2 xradio KCFG=""
1199 lfsmake2 linux-initrd KCFG=""
1200
1201 lfsmake2 libgpg-error
1202 lfsmake2 libgcrypt
1203 lfsmake2 libassuan
1204 lfsmake2 nettle
1205 lfsmake2 json-c
1206 lfsmake2 libconfig
1207 lfsmake2 libevent
1208 lfsmake2 libevent2
1209 lfsmake2 expat
1210 lfsmake2 apr
1211 lfsmake2 aprutil
1212 lfsmake2 unbound
1213 lfsmake2 gnutls
1214 lfsmake2 libuv
1215 lfsmake2 bind
1216 lfsmake2 dhcp
1217 lfsmake2 dhcpcd
1218 lfsmake2 boost
1219 lfsmake2 linux-atm
1220 lfsmake2 gdbm
1221 lfsmake2 pam
1222 lfsmake2 c-ares
1223 lfsmake2 curl
1224 lfsmake2 tcl
1225 lfsmake2 sqlite
1226 lfsmake2 libffi
1227 lfsmake2 python3
1228 lfsmake2 rust
1229 lfsmake2 rust-dissimilar
1230 lfsmake2 rust-cfg-if
1231 lfsmake2 rust-libc
1232 lfsmake2 rust-getrandom
1233 lfsmake2 rust-typenum
1234 lfsmake2 rust-version-check
1235 lfsmake2 rust-generic-array
1236 lfsmake2 rust-cipher
1237 lfsmake2 rust-hex
1238 lfsmake2 rust-unicode-xid
1239 lfsmake2 rust-proc-macro2
1240 lfsmake2 rust-quote
1241 lfsmake2 rust-syn
1242 lfsmake2 rust-home
1243 lfsmake2 rust-lazy-static
1244 lfsmake2 rust-memchr
1245 lfsmake2 rust-aho-corasick
1246 lfsmake2 rust-regex-syntax
1247 lfsmake2 rust-regex
1248 lfsmake2 rust-ucd-trie
1249 lfsmake2 rust-pest
1250 lfsmake2 rust-semver-parser
1251 lfsmake2 rust-semver
1252 lfsmake2 rust-same-file
1253 lfsmake2 rust-walkdir
1254 lfsmake2 rust-dirs
1255 lfsmake2 rust-toolchain_find
1256 lfsmake2 rust-serde
1257 lfsmake2 rust-itoa
1258 lfsmake2 rust-ryu
1259 lfsmake2 rust-serde_json
1260 lfsmake2 rust-synstructure
1261 lfsmake2 rust-block-buffer
1262 lfsmake2 rust-crypto-common
1263 lfsmake2 rust-digest
1264 lfsmake2 rust-ppv-lite86
1265 lfsmake2 rust-rand_core
1266 lfsmake2 rust-rand_core-0.4.2
1267 lfsmake2 rust-rand_core-0.3.1
1268 lfsmake2 rust-rand_chacha
1269 lfsmake2 rust-rand_hc
1270 lfsmake2 rust-rand
1271 lfsmake2 rust-rdrand
1272 lfsmake2 rust-rand-0.4
1273 lfsmake2 rust-log
1274 lfsmake2 rust-num_cpus
1275 lfsmake2 rust-crossbeam-utils
1276 lfsmake2 rust-autocfg
1277 lfsmake2 rust-memoffset
1278 lfsmake2 rust-scopeguard
1279 lfsmake2 rust-crossbeam-epoch
1280 lfsmake2 rust-crossbeam-deque
1281 lfsmake2 rust-either
1282 lfsmake2 rust-crossbeam-channel
1283 lfsmake2 rust-rayon-core
1284 lfsmake2 rust-rayon
1285 lfsmake2 rust-remove_dir_all
1286 lfsmake2 rust-tempdir
1287 lfsmake2 rust-glob
1288 lfsmake2 rust-once_cell
1289 lfsmake2 rust-termcolor
1290 lfsmake2 rust-toml
1291 lfsmake2 rust-serde_derive
1292 lfsmake2 rust-trybuild
1293 lfsmake2 rust-unindent
1294 lfsmake2 rust-proc-macro-hack
1295 lfsmake2 rust-indoc-impl
1296 lfsmake2 rust-indoc
1297 lfsmake2 rust-instant
1298 lfsmake2 rust-lock_api
1299 lfsmake2 rust-smallvec
1300 lfsmake2 rust-parking_lot_core
1301 lfsmake2 rust-parking_lot
1302 lfsmake2 rust-paste-impl
1303 lfsmake2 rust-paste
1304 lfsmake2 rust-ctor
1305 lfsmake2 rust-ghost
1306 lfsmake2 rust-inventory-impl
1307 lfsmake2 rust-inventory
1308 lfsmake2 rust-pyo3-build-config
1309 lfsmake2 rust-pyo3-macros-backend
1310 lfsmake2 rust-pyo3-macros
1311 lfsmake2 rust-pyo3
1312 lfsmake2 gdb
1313 lfsmake2 grub
1314 lfsmake2 efivar
1315 lfsmake2 efibootmgr
1316 lfsmake2 libtasn1
1317 lfsmake2 p11-kit
1318 lfsmake2 ca-certificates
1319 lfsmake2 fireinfo
1320 lfsmake2 libnet
1321 lfsmake2 libnl
1322 lfsmake2 libnl-3
1323 lfsmake2 libidn
1324 lfsmake2 nasm
1325 lfsmake2 libarchive
1326 lfsmake2 cmake
1327 lfsmake2 ninja
1328 lfsmake2 meson
1329 lfsmake2 libjpeg
1330 lfsmake2 openjpeg
1331 lfsmake2 libexif
1332 lfsmake2 libpng
1333 lfsmake2 libtiff
1334 lfsmake2 gd
1335 lfsmake2 slang
1336 lfsmake2 newt
1337 lfsmake2 libsmooth
1338 lfsmake2 libcap
1339 lfsmake2 libcap-ng
1340 lfsmake2 pciutils
1341 lfsmake2 usbutils
1342 lfsmake2 libxml2
1343 lfsmake2 libxslt
1344 lfsmake2 perl-BerkeleyDB
1345 lfsmake2 cyrus-sasl
1346 lfsmake2 openldap
1347 lfsmake2 apache2
1348 lfsmake2 web-user-interface
1349 lfsmake2 flag-icons
1350 lfsmake2 jquery
1351 lfsmake2 bootstrap
1352 lfsmake2 arping
1353 lfsmake2 beep
1354 lfsmake2 libssh
1355 lfsmake2 libinih
1356 lfsmake2 cdrkit
1357 lfsmake2 dosfstools
1358 lfsmake2 exfatprogs
1359 lfsmake2 reiserfsprogs
1360 lfsmake2 liburcu
1361 lfsmake2 xfsprogs
1362 lfsmake2 sysfsutils
1363 lfsmake2 fuse
1364 lfsmake2 ntfs-3g
1365 lfsmake2 ethtool
1366 lfsmake2 fcron
1367 lfsmake2 perl-ExtUtils-PkgConfig
1368 lfsmake2 perl-GD
1369 lfsmake2 perl-GD-Graph
1370 lfsmake2 perl-GD-TextUtil
1371 lfsmake2 perl-Device-SerialPort
1372 lfsmake2 perl-Device-Modem
1373 lfsmake2 perl-Apache-Htpasswd
1374 lfsmake2 perl-Parse-Yapp
1375 lfsmake2 perl-Data-UUID
1376 lfsmake2 perl-Try-Tiny
1377 lfsmake2 perl-HTTP-Message
1378 lfsmake2 perl-HTTP-Date
1379 lfsmake2 gnupg
1380 lfsmake2 hdparm
1381 lfsmake2 sdparm
1382 lfsmake2 whatmask
1383 lfsmake2 libtirpc
1384 lfsmake2 conntrack-tools
1385 lfsmake2 iputils
1386 lfsmake2 l7-protocols
1387 lfsmake2 hwdata
1388 lfsmake2 logrotate
1389 lfsmake2 logwatch
1390 lfsmake2 misc-progs
1391 lfsmake2 nano
1392 lfsmake2 perl-URI
1393 lfsmake2 perl-CGI
1394 lfsmake2 perl-Switch
1395 lfsmake2 perl-HTML-Tagset
1396 lfsmake2 perl-HTML-Parser
1397 lfsmake2 perl-HTML-Template
1398 lfsmake2 perl-Compress-Zlib
1399 lfsmake2 perl-Digest
1400 lfsmake2 perl-Digest-SHA1
1401 lfsmake2 perl-Digest-HMAC
1402 lfsmake2 perl-libwww
1403 lfsmake2 perl-LWP-Protocol-https
1404 lfsmake2 perl-Net-HTTP
1405 lfsmake2 perl-Net-DNS
1406 lfsmake2 perl-Net-IPv4Addr
1407 lfsmake2 perl-Net_SSLeay
1408 lfsmake2 perl-IO-Stringy
1409 lfsmake2 perl-IO-Socket-SSL
1410 lfsmake2 perl-Unix-Syslog
1411 lfsmake2 perl-Mail-Tools
1412 lfsmake2 perl-MIME-Tools
1413 lfsmake2 perl-Net-Server
1414 lfsmake2 perl-Canary-Stability
1415 lfsmake2 perl-Convert-TNEF
1416 lfsmake2 perl-Convert-UUlib
1417 lfsmake2 perl-Archive-Tar
1418 lfsmake2 perl-Archive-Zip
1419 lfsmake2 perl-Text-Tabs+Wrap
1420 lfsmake2 perl-XML-Parser
1421 lfsmake2 perl-Crypt-PasswdMD5
1422 lfsmake2 perl-Net-Telnet
1423 lfsmake2 python3-setuptools
1424 lfsmake2 python3-inotify
1425 lfsmake2 python3-docutils
1426 lfsmake2 python3-daemon
1427 lfsmake2 glib
1428 lfsmake2 ntp
1429 lfsmake2 openssh
1430 lfsmake2 fontconfig
1431 lfsmake2 dejavu-fonts-ttf
1432 lfsmake2 ubuntu-font-family
1433 lfsmake2 freefont
1434 lfsmake2 pixman
1435 lfsmake2 cairo
1436 lfsmake2 harfbuzz
1437 lfsmake2 fribidi
1438 lfsmake2 pango
1439 lfsmake2 rrdtool
1440 lfsmake2 setup
1441 lfsmake2 jansson
1442 lfsmake2 yaml
1443 lfsmake2 libhtp
1444 lfsmake2 colm
1445 lfsmake2 ragel
1446 lfsmake2 hyperscan
1447 lfsmake2 suricata
1448 lfsmake2 oinkmaster
1449 lfsmake2 ids-ruleset-sources
1450 lfsmake2 squid
1451 lfsmake2 squidguard
1452 lfsmake2 calamaris
1453 lfsmake2 tcpdump
1454 lfsmake2 traceroute
1455 lfsmake2 vlan
1456 lfsmake2 wireless
1457 lfsmake2 pakfire
1458 lfsmake2 spandsp
1459 lfsmake2 lz4
1460 lfsmake2 lzo
1461 lfsmake2 openvpn
1462 lfsmake2 mpage
1463 lfsmake2 dbus
1464 lfsmake2 intltool
1465 lfsmake2 libdaemon
1466 lfsmake2 avahi
1467 lfsmake2 cups
1468 lfsmake2 lcms2
1469 lfsmake2 ghostscript
1470 lfsmake2 qpdf
1471 lfsmake2 poppler
1472 lfsmake2 poppler-data
1473 lfsmake2 cups-filters
1474 lfsmake2 epson-inkjet-printer-escpr
1475 lfsmake2 foomatic
1476 lfsmake2 hplip
1477 lfsmake2 cifs-utils
1478 lfsmake2 krb5
1479 lfsmake2 rpcsvc-proto
1480 lfsmake2 samba
1481 lfsmake2 netatalk
1482 lfsmake2 sudo
1483 lfsmake2 mc
1484 lfsmake2 wget
1485 lfsmake2 bridge-utils
1486 lfsmake2 smartmontools
1487 lfsmake2 htop
1488 lfsmake2 chkconfig
1489 lfsmake2 postfix
1490 lfsmake2 fetchmail
1491 lfsmake2 clamav
1492 lfsmake2 perl-NetAddr-IP
1493 lfsmake2 dma
1494 lfsmake2 alsa
1495 lfsmake2 mpfire
1496 lfsmake2 guardian
1497 lfsmake2 libid3tag
1498 lfsmake2 libmad
1499 lfsmake2 libogg
1500 lfsmake2 libvorbis
1501 lfsmake2 flac
1502 lfsmake2 lame
1503 lfsmake2 sox
1504 lfsmake2 soxr
1505 lfsmake2 libshout
1506 lfsmake2 xvid
1507 lfsmake2 libmpeg2
1508 lfsmake2 gnump3d
1509 lfsmake2 rsync
1510 lfsmake2 rpcbind
1511 lfsmake2 keyutils
1512 lfsmake2 nfs
1513 lfsmake2 gnu-netcat
1514 lfsmake2 ncat
1515 lfsmake2 nmap
1516 lfsmake2 etherwake
1517 lfsmake2 bwm-ng
1518 lfsmake2 sysstat
1519 lfsmake2 strongswan
1520 lfsmake2 rng-tools
1521 lfsmake2 lsof
1522 lfsmake2 br2684ctl
1523 lfsmake2 pcmciautils
1524 lfsmake2 lm_sensors
1525 lfsmake2 libstatgrab
1526 lfsmake2 liboping
1527 lfsmake2 collectd
1528 lfsmake2 elinks
1529 lfsmake2 igmpproxy
1530 lfsmake2 opus
1531 lfsmake2 python3-pyparsing
1532 lfsmake2 spice-protocol
1533 lfsmake2 spice
1534 lfsmake2 sdl2
1535 lfsmake2 libusbredir
1536 lfsmake2 libseccomp
1537 lfsmake2 qemu
1538 lfsmake2 netpbm
1539 lfsmake2 netsnmpd
1540 lfsmake2 nagios_nrpe
1541 lfsmake2 nagios-plugins
1542 lfsmake2 icinga
1543 lfsmake2 observium-agent
1544 lfsmake2 ebtables
1545 lfsmake2 faad2
1546 lfsmake2 alac
1547 lfsmake2 ffmpeg
1548 lfsmake2 vdr
1549 lfsmake2 vdr_streamdev
1550 lfsmake2 vdr_epgsearch
1551 lfsmake2 vdr_dvbapi
1552 lfsmake2 vdr_eepg
1553 lfsmake2 w_scan
1554 lfsmake2 mpd
1555 lfsmake2 libmpdclient
1556 lfsmake2 mpc
1557 lfsmake2 perl-Net-CIDR-Lite
1558 lfsmake2 perl-Net-SMTP-SSL
1559 lfsmake2 perl-MIME-Base64
1560 lfsmake2 perl-Authen-SASL
1561 lfsmake2 perl-MIME-Lite
1562 lfsmake2 perl-Email-Date-Format
1563 lfsmake2 git
1564 lfsmake2 squidclamav
1565 lfsmake2 vnstat
1566 lfsmake2 iw
1567 lfsmake2 wpa_supplicant
1568 lfsmake2 hostapd
1569 lfsmake2 syslinux
1570 lfsmake2 tftpd
1571 lfsmake2 cpufrequtils
1572 lfsmake2 gutenprint
1573 lfsmake2 apcupsd
1574 lfsmake2 fireperf
1575 lfsmake2 iperf
1576 lfsmake2 iperf3
1577 lfsmake2 7zip
1578 lfsmake2 lynis
1579 lfsmake2 sshfs
1580 lfsmake2 taglib
1581 lfsmake2 sslh
1582 lfsmake2 perl-gettext
1583 lfsmake2 perl-Sort-Naturally
1584 lfsmake2 vdradmin
1585 lfsmake2 perl-DBI
1586 lfsmake2 perl-DBD-SQLite
1587 lfsmake2 perl-File-ReadBackwards
1588 lfsmake2 openvmtools
1589 lfsmake2 joe
1590 lfsmake2 monit
1591 lfsmake2 nut
1592 lfsmake2 watchdog
1593 lfsmake2 usb_modeswitch
1594 lfsmake2 usb_modeswitch_data
1595 lfsmake2 zerofree
1596 lfsmake2 minicom
1597 lfsmake2 ddrescue
1598 lfsmake2 powertop
1599 lfsmake2 parted
1600 lfsmake2 swig
1601 lfsmake2 dtc
1602 lfsmake2 u-boot
1603 lfsmake2 u-boot-friendlyarm
1604 lfsmake2 wireless-regdb
1605 lfsmake2 ddns
1606 lfsmake2 python3-pycparser
1607 lfsmake2 python3-charset-normalizer
1608 lfsmake2 python3-certifi
1609 lfsmake2 python3-idna
1610 lfsmake2 python3-requests
1611 lfsmake2 python3-toml
1612 lfsmake2 python3-pyproject2setuppy
1613 lfsmake2 python3-tomli
1614 lfsmake2 python3-pep517
1615 lfsmake2 python3-build
1616 lfsmake2 python3-install
1617 lfsmake2 python3-urllib3
1618 lfsmake2 python3-flit
1619 lfsmake2 python3-packaging
1620 lfsmake2 python3-typing-extensions
1621 lfsmake2 python3-semantic-version
1622 lfsmake2 python3-setuptools-scm
1623 lfsmake2 python3-setuptools-rust
1624 lfsmake2 python3-six
1625 lfsmake2 python3-dateutil
1626 lfsmake2 python3-jmespath
1627 lfsmake2 python3-colorama
1628 lfsmake2 python3-yaml
1629 lfsmake2 python3-s3transfer
1630 lfsmake2 python3-rsa
1631 lfsmake2 python3-pyasn1
1632 lfsmake2 python3-botocore
1633 lfsmake2 python3-cffi
1634 lfsmake2 python3-cryptography
1635 lfsmake2 python3-circuitbreaker
1636 lfsmake2 python3-pytz
1637 lfsmake2 python3-click
1638 lfsmake2 python3-arrow
1639 lfsmake2 python3-terminaltables
1640 lfsmake2 aws-cli
1641 lfsmake2 oci-python-sdk
1642 lfsmake2 oci-cli
1643 lfsmake2 transmission
1644 lfsmake2 mtr
1645 lfsmake2 minidlna
1646 lfsmake2 acpid
1647 lfsmake2 fping
1648 lfsmake2 telnet
1649 lfsmake2 xinetd
1650 lfsmake2 stress
1651 lfsmake2 sarg
1652 lfsmake2 nginx
1653 lfsmake2 sysbench
1654 lfsmake2 strace
1655 lfsmake2 ltrace
1656 lfsmake2 ipfire-netboot
1657 lfsmake2 lcdproc
1658 lfsmake2 keepalived
1659 lfsmake2 ipvsadm
1660 lfsmake2 perl-Carp-Clan
1661 lfsmake2 perl-Date-Calc
1662 lfsmake2 perl-Date-Manip
1663 lfsmake2 perl-File-Tail
1664 lfsmake2 perl-TimeDate
1665 lfsmake2 swatch
1666 lfsmake2 tor
1667 lfsmake2 wavemon
1668 lfsmake2 iptraf-ng
1669 lfsmake2 iotop
1670 lfsmake2 stunnel
1671 lfsmake2 bacula
1672 lfsmake2 perl-Font-TTF
1673 lfsmake2 perl-IO-String
1674 lfsmake2 perl-PDF-API2
1675 lfsmake2 proxy-accounting
1676 lfsmake2 pigz
1677 lfsmake2 tmux
1678 lfsmake2 perl-Text-CSV_XS
1679 lfsmake2 lua
1680 lfsmake2 haproxy
1681 lfsmake2 ipset
1682 lfsmake2 dnsdist
1683 lfsmake2 bird
1684 lfsmake2 libyang
1685 lfsmake2 frr
1686 lfsmake2 dmidecode
1687 lfsmake2 mcelog
1688 lfsmake2 libpciaccess
1689 lfsmake2 libyajl
1690 lfsmake2 libvirt
1691 lfsmake2 libtalloc
1692 lfsmake2 freeradius
1693 lfsmake2 perl-common-sense
1694 lfsmake2 perl-inotify2
1695 lfsmake2 perl-Net-IP
1696 lfsmake2 wio
1697 lfsmake2 iftop
1698 lfsmake2 mdns-repeater
1699 lfsmake2 i2c-tools
1700 lfsmake2 nss-myhostname
1701 lfsmake2 dehydrated
1702 lfsmake2 shairport-sync
1703 lfsmake2 borgbackup
1704 lfsmake2 lmdb
1705 lfsmake2 knot
1706 lfsmake2 spectre-meltdown-checker
1707 lfsmake2 zabbix_agentd
1708 lfsmake2 flashrom
1709 lfsmake2 firmware-update
1710 lfsmake2 tshark
1711 lfsmake2 speedtest-cli
1712 lfsmake2 amazon-ssm-agent
1713 lfsmake2 libloc
1714 lfsmake2 ncdu
1715 lfsmake2 lshw
1716 lfsmake2 socat
1717 lfsmake2 libcdada
1718 lfsmake2 pmacct
1719 lfsmake2 squid-asnbl
1720 lfsmake2 qemu-ga
1721 lfsmake2 gptfdisk
1722 }
1723
1724 buildinstaller() {
1725 # Run installer scripts one by one
1726 LOGFILE="$BASEDIR/log/_build.installer.log"
1727 export LOGFILE
1728 lfsmake2 memtest
1729 lfsmake2 installer
1730 # use toolchain bash for chroot to strip
1731 CUSTOM_PATH="${TOOLS_DIR}/bin" lfsmake2 strip
1732 }
1733
1734 buildpackages() {
1735 LOGFILE="$BASEDIR/log/_build.packages.log"
1736 export LOGFILE
1737 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1738
1739
1740 # Generating list of packages used
1741 print_line "Generating packages list from logs"
1742 rm -f $BASEDIR/doc/packages-list
1743 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1744 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1745 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1746 fi
1747 done
1748 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1749 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1750 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1751 rm -f $BASEDIR/doc/packages-list
1752 # packages-list.txt is ready to be displayed for wiki page
1753 print_status DONE
1754
1755 # Update changelog
1756 cd $BASEDIR
1757 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1758 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1759 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1760
1761 # Create images for install
1762 lfsmake2 cdrom
1763
1764 # Check if there is a loop device for building in virtual environments
1765 modprobe loop 2>/dev/null
1766 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1767 lfsmake2 flash-images
1768 fi
1769
1770 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1771
1772 ipfirepackages
1773
1774 cd $BASEDIR
1775
1776 # remove not useable iso on armv6l (needed to build flash images)
1777 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
1778
1779 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
1780 b2sum $i > $i.b2
1781 done
1782 cd $PWD
1783
1784 # Cleanup
1785 stdumount
1786 rm -rf $BASEDIR/build/tmp/*
1787
1788 cd $PWD
1789 }
1790
1791 ipfirepackages() {
1792 lfsmake2 core-updates
1793
1794 local i
1795 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1796 i=$(basename ${i})
1797 if [ -e $BASEDIR/lfs/$i ]; then
1798 ipfiredist $i
1799 else
1800 echo -n $i
1801 print_status SKIP
1802 fi
1803 done
1804 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1805 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1806 rm -rf $BASEDIR/build/install/packages/*
1807 }
1808
1809 while [ $# -gt 0 ]; do
1810 case "${1}" in
1811 --target=*)
1812 configure_build "${1#--target=}"
1813 ;;
1814 -*)
1815 exiterror "Unknown configuration option: ${1}"
1816 ;;
1817 *)
1818 # Found a command, so exit options parsing.
1819 break
1820 ;;
1821 esac
1822 shift
1823 done
1824
1825 # See what we're supposed to do
1826 case "$1" in
1827 build)
1828 START_TIME="${SECONDS}"
1829
1830 # Clear screen
1831 ${INTERACTIVE} && clear
1832
1833 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
1834 #only restore on a clean disk
1835 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1836 if [ ! -n "$PACKAGE" ]; then
1837 print_build_stage "Full toolchain compilation"
1838 prepareenv
1839 buildtoolchain
1840 else
1841 PACKAGENAME=${PACKAGE%.tar.zst}
1842 print_build_stage "Packaged toolchain compilation"
1843 if [ `b2sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.b2 | awk '{print $1}'` ]; then
1844 zstd -d < "${PACKAGE}" | tar x
1845 prepareenv
1846 else
1847 exiterror "$PACKAGENAME BLAKE2 checksum did not match, check downloaded package"
1848 fi
1849 fi
1850 else
1851 prepareenv
1852 fi
1853
1854 print_build_stage "Building LFS"
1855 buildbase
1856
1857 print_build_stage "Building IPFire"
1858 buildipfire
1859
1860 print_build_stage "Building installer"
1861 buildinstaller
1862
1863 print_build_stage "Building packages"
1864 buildpackages
1865
1866 print_build_stage "Checking Logfiles for new Files"
1867
1868 cd $BASEDIR
1869 tools/checknewlog.pl
1870 tools/checkrootfiles
1871 cd $PWD
1872
1873 print_build_summary $(( SECONDS - START_TIME ))
1874 ;;
1875 shell)
1876 # enter a shell inside LFS chroot
1877 # may be used to changed kernel settings
1878 prepareenv
1879 entershell
1880 ;;
1881 clean)
1882 print_line "Cleaning build directory..."
1883
1884 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1885 $LOSETUP -d $i 2>/dev/null
1886 done
1887 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1888 # umount $i
1889 #done
1890 stdumount
1891 for i in `seq 0 7`; do
1892 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1893 umount /dev/loop${i} 2>/dev/null;
1894 losetup -d /dev/loop${i} 2>/dev/null;
1895 fi;
1896 done
1897 rm -rf $BASEDIR/build
1898 rm -rf $BASEDIR/cdrom
1899 rm -rf $BASEDIR/packages
1900 rm -rf $BASEDIR/log
1901 if [ -h "${TOOLS_DIR}" ]; then
1902 rm -f "${TOOLS_DIR}"
1903 fi
1904 rm -f $BASEDIR/ipfire-*
1905 print_status DONE
1906 ;;
1907 docker)
1908 # Build the docker image if it does not exist, yet
1909 if ! docker images -a | grep -q ^ipfire-builder; then
1910 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1911 print_status DONE
1912 else
1913 print_status FAIL
1914 exit 1
1915 fi
1916 fi
1917
1918 # Run the container and enter a shell
1919 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1920 ;;
1921 downloadsrc)
1922 if [ ! -d $BASEDIR/cache ]; then
1923 mkdir $BASEDIR/cache
1924 fi
1925 mkdir -p $BASEDIR/log
1926 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1927 FINISHED=0
1928 cd $BASEDIR/lfs
1929 for c in `seq $MAX_RETRIES`; do
1930 if (( FINISHED==1 )); then
1931 break
1932 fi
1933 FINISHED=1
1934 cd $BASEDIR/lfs
1935 for i in *; do
1936 if [ -f "$i" -a "$i" != "Config" ]; then
1937 lfsmakecommoncheck ${i} || continue
1938
1939 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1940 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1941 if [ $? -ne 0 ]; then
1942 print_status FAIL
1943 FINISHED=0
1944 else
1945 if [ $c -eq 1 ]; then
1946 print_status DONE
1947 fi
1948 fi
1949 fi
1950 done
1951 done
1952 echo -e "${BOLD}***Verifying BLAKE2 checksum${NORMAL}"
1953 ERROR=0
1954 for i in *; do
1955 if [ -f "$i" -a "$i" != "Config" ]; then
1956 lfsmakecommoncheck ${i} > /dev/null || continue
1957 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1958 MESSAGE="$i\t " b2 >> $LOGFILE 2>&1
1959 if [ $? -ne 0 ]; then
1960 echo -ne "BLAKE2 checksum difference in lfs/$i"
1961 print_status FAIL
1962 ERROR=1
1963 fi
1964 fi
1965 done
1966 if [ $ERROR -eq 0 ]; then
1967 echo -ne "${BOLD}all files BLAKE2 checksum match${NORMAL}"
1968 print_status DONE
1969 else
1970 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1971 print_status FAIL
1972 fi
1973 cd - >/dev/null 2>&1
1974 ;;
1975 toolchain)
1976 # Clear screen
1977 ${INTERACTIVE} && clear
1978
1979 prepareenv
1980 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1981 buildtoolchain
1982 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1983 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1984 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1985 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1986 b2sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
1987 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.b2
1988 stdumount
1989 ;;
1990 gettoolchain)
1991 # arbitrary name to be updated in case of new toolchain package upload
1992 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1993 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
1994 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1995 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1996 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1997 cd $BASEDIR/cache/toolchains
1998 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.b2 >& /dev/null
1999 if [ $? -ne 0 ]; then
2000 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
2001 else
2002 if [ "`b2sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.b2 | awk '{print $1}'`" ]; then
2003 echo "`date -u '+%b %e %T'`: toolchain BLAKE2 checksum ok" | tee -a $LOGFILE
2004 else
2005 exiterror "$PACKAGE BLAKE2 checksum did not match, check downloaded package"
2006 fi
2007 fi
2008 else
2009 echo "Toolchain is already downloaded. Exiting..."
2010 fi
2011 ;;
2012 uploadsrc)
2013 if [ -z $IPFIRE_USER ]; then
2014 echo -n "You have to setup IPFIRE_USER first. See .config for details."
2015 print_status FAIL
2016 exit 1
2017 fi
2018
2019 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
2020
2021 rsync \
2022 --recursive \
2023 --update \
2024 --ignore-existing \
2025 --progress \
2026 --human-readable \
2027 --exclude="toolchains/" \
2028 "${BASEDIR}/cache/" \
2029 "${IPFIRE_USER}@${URL_SOURCE}"
2030
2031 exit 0
2032 ;;
2033 lang)
2034 echo -ne "Checking the translations for missing or obsolete strings..."
2035 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
2036 $BASEDIR/tools/sort_strings.pl en
2037 $BASEDIR/tools/sort_strings.pl de
2038 $BASEDIR/tools/sort_strings.pl fr
2039 $BASEDIR/tools/sort_strings.pl es
2040 $BASEDIR/tools/sort_strings.pl pl
2041 $BASEDIR/tools/sort_strings.pl ru
2042 $BASEDIR/tools/sort_strings.pl nl
2043 $BASEDIR/tools/sort_strings.pl tr
2044 $BASEDIR/tools/sort_strings.pl it
2045 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
2046 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
2047 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
2048 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
2049 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
2050 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
2051 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
2052 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
2053 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
2054 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
2055 print_status DONE
2056
2057 echo -ne "Updating language lists..."
2058 update_language_list ${BASEDIR}/src/installer/po
2059 update_language_list ${BASEDIR}/src/setup/po
2060 print_status DONE
2061 ;;
2062 update-contributors)
2063 update_contributors
2064 ;;
2065 find-dependencies)
2066 shift
2067 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
2068 ;;
2069 check-manualpages)
2070 echo "Checking the manual pages for broken links..."
2071
2072 chmod 755 $BASEDIR/tools/check_manualpages.pl
2073 if $BASEDIR/tools/check_manualpages.pl; then
2074 print_status DONE
2075 else
2076 print_status FAIL
2077 fi
2078 ;;
2079 *)
2080 echo "Usage: $0 [OPTIONS] {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies|check-manualpages}"
2081 cat doc/make.sh-usage
2082 ;;
2083 esac